# sac.tcl---Silena S9418 DA Control module control frame



set frame "SAC"
set frametitle "Data Acquisition Control module"
set icontitle "SAC"

set modulename sac
set module 1


loadsource common.vme


proc click-delr {value} {
    global modulename module

    set register DELR
    write-vme-register $modulename#$module.$register $value
}

proc click-arm {} {
    global modulename module

    set register ARM
    write-vme-register $modulename#$module.$register 0
}

proc click-str {value} {
    global modulename module

    set register STR
    write-vme-register $modulename#$module.$register $value
}

proc click-acq {value} {
    global modulename module

    set register Enable
    write-vme-register $modulename#$module.$register $value
}

proc click-mon {value} {
    global modulename module

    set register MON0
    write-vme-register $modulename#$module.$register $value
}

proc click-mode {value} {
    global modulename module

    set register Mode
    write-vme-register $modulename#$module.$register $value
}

proc click-eventclr {} {
    global modulename module

    set register EVCLR
    write-vme-register $modulename#$module.$register 0
}

proc click-software {} {
   global modulename
   inform [set modulename]sftwre start
}

proc click-redisplay {} {
    global modulename module

    set register DELR
    set vl [read-vme-register $modulename#$module.$register]
    :modify DELR :value [expr $vl & 255]

    set register STR
    set vl [read-vme-register $modulename#$module.$register]
    :modify STR :value [format "0x%x" [expr $vl & 255]]

    set register Enable
    set vl [read-vme-register $modulename#$module.$register]
    :modify ACQ :value $vl

    set register EVCNT
    set vl [read-vme-register $modulename#$module.$register]
    :modify EVCNT :value $vl

    set register MON0
    set vl [read-vme-register $modulename#$module.$register]
    :modify MON :value $vl

    set register CBUS
    set vl [read-vme-register $modulename#$module.$register]
    :modify CBUS :value $vl

    set register Mode
    set vl [read-vme-register $modulename#$module.$register]
    :modify MODE :value $vl
}

proc start args {
   global started

   if {$started == 0} then {
       make-frame
       EGbindings
   }
   set started 1
   open-frame

   clear-footer
   clear-busy
   set EGreport 0

   click-redisplay
}

proc click-quit {} {close-frame}

proc finish args {destroy-frame}


proc click arg {
   global debug actionlist
   if {$debug} then {insert-debug "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   set i [lindex $arg 4]

   if {$c==":quit"} then {click-quit; return}
   switch -glob $w {
      ENGINEERING       {click-$v}
      DELR              {click-delr $v}
      STR               {click-str $v}
      ACQ               {click-acq $v}
      MON               {click-mon $v}
      MODE              {click-mode $v}
      ARM               {click-arm}
      EVCLR             {click-eventclr}
      RESET             {click-str 2; click-str 0}
      default           {}
   }
}


proc make-frame {} {
  global env
  :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-image "@$env(ICONHOME)/vme_module" \
      :icon-name "[self icon-title]" :resize F

   :panel MODULE  :layout T :padx 10 :pady 10
     :layout V; :row-gap 10; :col-gap 10

     :slider DELR       :label "Trigger Delay (25ns)"  :min 0 :max 255  :valuex 18c
     :text STR          :label  Status :w 4  :valuex 18c
     :checkbox ACQ      :label "Acquisition Enabled" :valuex 18c
     :text EVCNT        :label "Event Counter" :valuex 18c :deaf T
     :choice CBUS       :label "Command Bus" :strings [list COM MDTRG GATEn RJTRG GLTRG GLINH] :deaf T :valuex 18c :exclusive F
     :choice MON        :label "Monitor Source" :strings [list trigger reject COM GATEn MDTRG RJTRG GLTRG GLINH] :valuex 18c
     :choice MODE       :label "Operation Mode" :strings [list Silena CAEN] :valuex 18c
       :layout H; :next-row T
     :button EVCLR      :label "Clear Event Counter"
     :button RESET      :label "Reset State Machine"
     :button ARM
     

   :panel CLICK :layout B :padx 10 :after FOOTER
     :layout H; :col-gap 30; :row-gap 10
      :vskip 10
      :button REDISPLAY  :command click-redisplay
      :menubutton ENGINEERING :label "Engineering"  :menu [list software]

  :show T

}


